###### 1. Import the dataset #######
# This imports the function `data_as_list_of_lists` from `data.py`
# This only works if `data.py` is in this folder
from data import data_header, data_as_list_of_lists

# Load the header and the dataset
baseball_header = data_header("lahman_batting.csv")
baseball_data = data_as_list_of_lists("lahman_batting.csv")

###### 2.1 Viewing snippets of the data ########
# As before, this data is in the form of a list of lists. Unlike before, it is
# too big to print out. Please write a function that prints the header and the
# first k records of any dataset you pass it:

def head(header, dataset, k):
    """
    Prints the header and the first k rows of a dataset (list-of-lists)
    Parameters: header (list), dataset (list-of-lists), k (integer)
    Returns: <nothing>
    """
    pass # your code here.

# As always, it will be helpful to inspect and understand the data. There is a
# codebook at the end of your handout that has the meaning of the columns.

###### 2.2 Filtering numeric columns ########

# We are often interested in specific subsets of datasets, and so one of the
# most practical data analysis techniques is to filter data. Write a function
# that uses what you've learned in previous weeks to subset data:

def find_subset_numerical(dataset, col_index, min_value, max_value):
    """
    Filters the dataset by a numerical column and return the specified subset

    Parameters: dataset (list-of-lists), col_index (integer), max/min_values (float)

    Returns: a (new) list-of-lists containing all those records in the `dataset`
    with a value in column `col_index` between `min_value` and `max_value`
    """
    subset = []
    pass # your code here
    return subset

# To evaluate this function, check that it can find these records:

# Check that your function returns the whole dataset when you give it very generous
# max and min values for one of the columns.
pass # your code here

# The record for hits in a season (H) is 262. Use your function to find this record.
pass # your code here
print("YOUR_ANSWER_HERE")

# The record for walks in a season (BB) is 232. Use your function to find this record.
pass # your code here
print("YOUR_ANSWER_HERE")

# Who stole 130 bases in 1982?
pass # your code here
print("YOUR_ANSWER_HERE")

###### 2.3 Filtering categorical columns #######

# We would also like to be able to filter string-valued columns. Write a function
# that uses what you've learned in previous weeks to subset data:

def find_subset_categorical(dataset, col_index, categories):
    """
    Filters the dataset by a categorical column and return the specified subset

    Parameters: dataset (list-of-lists), col_index (integer), categories (list)

    Returns: a (new) list-of-lists containing all those records in the `dataset`
    with a value in column `col_index` in the `categories` list
    """
    pass # your code here

# To evaluate this function, check that it can discern these known facts:

# Washington Nationals (WAS) replaced The Montreal Expos (MON) in 2004.
pass # your code here
print("YOUR_ANSWER_HERE")

# In this dataset (post-1969) there are only two leagues: AL and NL.
pass # your code here
print("YOUR_ANSWER_HERE")

###### 2.4 Franchise records ######

# Now that we have filtering functions, we can use them to find very specific
# records that we are interested in. For instance, please find and print the
# following single-season team records:

# Who was the Atlanta Braves (ATL) single-season strikeout leader?
# Hint: look for > 160 SO
pass # your code here
print("YOUR_ANSWER_HERE")

# Who was the Boston Red Sox (BOS) single-season home runs leader?
# Hint: look for > 50 HR
pass # your code here
print("YOUR_ANSWER_HERE")

##### 3. Ordering data #######

# Filtering is powerful, but less so if we don't know the record. Here, we will
# learn to use python's built-in `sorted` function to order our data.

##### 3.1 Helper functions #######

# Python's `sorted` function will sort any list you give it, and it behaves like
# you would expect for simple lists. But we want to use `sorted` to sort a list
# of lists, and the built-in function has no way of knowing what we mean by "sort"
# unless we tell it. We do this by passing the `sorted` function a `key` that it
# can use to sort with. Specifically, `key` needs to be a function that takes an
# entry of the list (ie. a row of this dataset) and returns the value to use.

# This is the helper function that `sorted` could use to sort a dataset by first name:
def get_first_name(row):
    return row[0]

# Write a helper function that `sorted` could use to sort by Year (year):

# Write a helper function that `sorted` could use to sort by Hits (H):

# Write a helper function that `sorted` could use to sort by Walks (BB):

# Write helper functions for any other stats you want to study:


##### 3.2 Single-season leaderboards #######

# We have everything we need to print the top player-seasons for different stats.
# Write a function that takes an input dataset, a helper function, and the top
# of top player-seasons you want to print. Hint: use your head function!

def leaderboard(header, dataset, sort_stat_helper, k):
    """
    Finds and prints the top k player-seasons for a particular statistic.

    Parameters: header (list), dataset (list-of-lists), sort_stat_helper (function), k (integer)

    Returns: <nothing> the function (reverse) sorts the dataset according to the
    statistic returned by `sort_stat_helper`, and prints the top k records
    """
    # Replace pass with your code!
    pass

# Before you report any important findings, you want to check that your function
# is working correctly by making sure it does what you expenct on common-sense
# examples. For instance, try:
leaderboard(baseball_header, baseball_data, get_first_name, 5)
    # This should give you 2 Zoilos and 3 Zacks (Z is the "biggest" letter)
    # Not working? There's a hint in your handout.

##### 3.3 Using leaderboards to find records #######

# Now, use your function to answer the following questions about the data:

# We saw before that 2004 Ichiro Suzuki set the record for hits in a season. He
# also holds second place -- for what year? Who is next?
pass # your code here

# How many times is Barry Bonds in the top 10 in walks in a season?
pass # your code here


##### Done already? Check the handout for extra practice! #######
